diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index fd38d5742..04769b748 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -11,6 +11,8 @@ import org.jetbrains.annotations.Nullable;
 
 import java.awt.image.BufferedImage;
 
+import static java.lang.Math.floorMod;
+
 public class DynamicTextureWaterStill extends DynamicTexture {
 	
 	private final Minecraft mc = Minecraft.getMinecraft();
@@ -53,8 +55,8 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 				float pow = 0.0F;
 
 				for (int xx = x - 1; xx <= x + 1; ++xx) {
-					final int xi = pmod(xx, this.targetTexture.width);
-					final int yi = pmod(y, this.targetTexture.height);
+					final int xi = floorMod(xx, this.targetTexture.width);
+					final int yi = floorMod(y, this.targetTexture.height);
 					pow += this.current[xi + yi * this.targetTexture.width];
 				}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
index c394a3896..824facdb1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
@@ -19,6 +19,8 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
         }
 
         bindTexture("/assets/minecraft/textures/entity/arrows.png");
+        float imgWidth = 16f;
+        float imgHeight = 64f;
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
 
@@ -27,14 +29,14 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
 
         int arrowType = arrow.getArrowType();
 
-        float bodyMinU = 0F / 32F;
-        float bodyMaxU = 16F / 32F;
-        float bodyMinV = (float) (arrowType * 10) / 32F;
-        float bodyMaxV = (float) (5 + arrowType * 10) / 32F;
-        float tailMinU = 0F / 32F;
-        float tailMaxU = 5F / 32F;
-        float tailMinV = (float) (5 + arrowType * 10) / 32F;
-        float tailMaxV = (float) (10 + arrowType * 10) / 32F;
+        float bodyMinU = 0F / imgWidth;
+        float bodyMaxU = 16F / imgWidth;
+        float bodyMinV = (float) (arrowType * 10) / imgHeight;
+        float bodyMaxV = (float) (5 + arrowType * 10) / imgHeight;
+        float tailMinU = 0F / imgWidth;
+        float tailMaxU = 5F / imgWidth;
+        float tailMinV = (float) (5 + arrowType * 10) / imgHeight;
+        float tailMaxV = (float) (10 + arrowType * 10) / imgHeight;
         float scale = 9F / 160F;
 
         float shakeAmount = (float) arrow.shake - partialTick;
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
index 08c4e334a..0288e31b3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.font;
 
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -176,4 +177,8 @@ public abstract class FontRenderer {
     public void init() {
 
     }
+
+    public abstract void startDrawingDeferred();
+    public abstract void draw(double z);
+    public abstract @NotNull TessellatorFont.FontRenderBuffer record(int vao, int vbo);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 67cf599d0..1033abc2b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -24,6 +24,7 @@ public class FontRendererDefault extends FontRenderer {
     protected final long @NotNull [] configStack = new long[32];
     protected byte stackIndex = 0;
     protected long currentConfig = 0;
+    protected boolean drawingDeferred = false;
 
     protected int currentTex = -1;
     protected final Random random;
@@ -50,6 +51,32 @@ public class FontRendererDefault extends FontRenderer {
         this.tessellatorFont = new TessellatorFont("FontRenderDefault Base Tessellator", 0x40000);
     }
 
+    @Override
+    public void startDrawingDeferred() {
+        if (this.drawingDeferred) throw new IllegalStateException("Already drawing deferred!");
+        this.drawingDeferred = true;
+        this.tessellatorFont.startDrawing();
+    }
+
+    @Override
+    public void draw(double z) {
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.globalSetUniforms(Shaders.FONT);
+        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
+        this.tessellatorFont.draw();
+
+        GLRenderer.popFrame();
+        this.drawingDeferred = false;
+    }
+
+    @Override
+    public @NotNull TessellatorFont.FontRenderBuffer record(int vao, int vbo) {
+        this.drawingDeferred = false;
+        return this.tessellatorFont.record(vao, vbo);
+    }
+
     private final StringBuilder renderStringInternal_colorValue = new StringBuilder();
     protected void renderStringInternal(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         double currX = x;
@@ -175,11 +202,6 @@ public class FontRendererDefault extends FontRenderer {
         return this.tessellatorFont;
     }
 
-    public void renderStringRaw(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig) {
-        this.currentConfig = baseConfig;
-        renderStringInternal(font, chars, x, y, z, shadow, baseConfig, null, null, null);
-    }
-
     protected double renderCharInternal(@NotNull final Font font, @NotNull final TessellatorFont tessellator, final char c, final double x, final double y, final double z, boolean shadow) {
         tessellator.setShadow(shadow);
         tessellator.setConfig(this.currentConfig);
@@ -201,21 +223,10 @@ public class FontRendererDefault extends FontRenderer {
         this.currentTex = -1;
         this.currentConfig = baseConfig;
         this.stackIndex = 0;
-        GLRenderer.pushFrame();
-        GLRenderer.enableState(State.BLEND);
-        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        GLRenderer.globalSetUniforms(Shaders.FONT);
-        Shaders.FONT.bind();
-        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-
-        this.tessellatorFont.startDrawing();
 
+        if (!this.drawingDeferred) this.tessellatorFont.startDrawing();
         renderStringInternal(font, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
-
-        Shaders.FONT.bind();
-        this.tessellatorFont.draw();
-
-        GLRenderer.popFrame();
+        if (!this.drawingDeferred) draw(z);
     }
 
     @Override
@@ -241,14 +252,7 @@ public class FontRendererDefault extends FontRenderer {
 
         final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
 
-        GLRenderer.pushFrame();
-        GLRenderer.enableState(State.BLEND);
-        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        GLRenderer.globalSetUniforms(Shaders.FONT);
-        Shaders.FONT.bind();
-        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-        this.tessellatorFont.startDrawing();
-
+        if (!this.drawingDeferred) this.tessellatorFont.startDrawing();
         double currY = y;
         switch (alignment) {
             case LEFT: {
@@ -276,9 +280,7 @@ public class FontRendererDefault extends FontRenderer {
                 break;
             }
         }
-        Shaders.FONT.bind();
-        this.tessellatorFont.draw();
-        GLRenderer.popFrame();
+        if (!this.drawingDeferred) draw(z);
 
         if (xPosBuffer != null) {
             xPosBuffer[0] = x + maxWidth;
@@ -299,15 +301,7 @@ public class FontRendererDefault extends FontRenderer {
 
         final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
 
-        GLRenderer.pushFrame();
-        GLRenderer.enableState(State.BLEND);
-        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        GLRenderer.globalSetUniforms(Shaders.FONT);
-        Shaders.FONT.bind();
-        GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-
-        this.tessellatorFont.startDrawing();
-
+        if (!this.drawingDeferred) this.tessellatorFont.startDrawing();
         int currY = y;
         switch (alignment) {
             case LEFT: {
@@ -335,9 +329,7 @@ public class FontRendererDefault extends FontRenderer {
                 break;
             }
         }
-        Shaders.FONT.bind();
-        this.tessellatorFont.draw();
-        GLRenderer.popFrame();
+        if (!this.drawingDeferred) draw(z);
 
         if (xPosBuffer != null) {
             xPosBuffer[0] = x + maxWidth;
@@ -358,45 +350,26 @@ public class FontRendererDefault extends FontRenderer {
 
         final List<String> lines = splitCharsIntoLines(chars, maxWidth, this.localStringList);
 
+        if (!this.drawingDeferred) this.tessellatorFont.startDrawing();
         double currY = y;
         this.localConfigBuffer[0] = baseConfig;
         switch (alignment) {
             case LEFT: {
-                GLRenderer.pushFrame();
-                GLRenderer.enableState(State.BLEND);
-                GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-                GLRenderer.globalSetUniforms(Shaders.FONT);
-                Shaders.FONT.bind();
-                GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-                this.tessellatorFont.startDrawing();
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
                     renderStringInternal(font, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
-                Shaders.FONT.bind();
-                this.tessellatorFont.draw();
-                GLRenderer.popFrame();
                 break;
             }
             case RIGHT: {
-                GLRenderer.pushFrame();
-                GLRenderer.enableState(State.BLEND);
-                GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-                GLRenderer.globalSetUniforms(Shaders.FONT);
-                Shaders.FONT.bind();
-                GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-                this.tessellatorFont.startDrawing();
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
                     renderStringInternal(font, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
                     currY += font.fontHeight() + 1;
                     if ((currY - y) > maxHeight) break;
                 }
-                Shaders.FONT.bind();
-                this.tessellatorFont.draw();
-                GLRenderer.popFrame();
                 break;
             }
             case CENTERED: {
@@ -409,6 +382,7 @@ public class FontRendererDefault extends FontRenderer {
                 break;
             }
         }
+        if (!this.drawingDeferred) draw(z);
 
         if (xPosBuffer != null) {
             xPosBuffer[0] = x + maxWidth;
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index a71958762..ba3709b7e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -19,12 +19,9 @@ import org.joml.Vector3fc;
 import org.joml.Vector4dc;
 import org.joml.Vector4f;
 import org.joml.Vector4fc;
-import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
-import java.nio.FloatBuffer;
-
 import static net.minecraft.client.render.uniform.UniformBlock.N;
 
 public class GLRenderer {
@@ -90,8 +87,8 @@ public class GLRenderer {
     private final Shader[] shaderStack = new Shader[RENDER_FRAMES_STACK_SIZE];
     private @NotNull Shader currentShader = Shaders.INTERFACE;
 
-    private final FogManager.FogState[] fogStateStack = new FogManager.FogState[RENDER_FRAMES_STACK_SIZE];
-    private @NotNull FogManager.FogState currentFogState = new FogManager.FogState().disable();
+    private final @NotNull FogManager.FogState @NotNull [] fogStateStack = new FogManager.FogState[RENDER_FRAMES_STACK_SIZE];
+    private final @NotNull FogManager.FogState currentFogState = new FogManager.FogState().disable();
     private boolean fogStateDirty = true;
 
     private final CompareFunc[] depthFuncStack = new CompareFunc[RENDER_FRAMES_STACK_SIZE];
@@ -135,10 +132,12 @@ public class GLRenderer {
 
 
     private final @NotNull Minecraft mc = Minecraft.getMinecraft();
-    private final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(16);
     private final @NotNull TessellatorShader tessellatorShader = new TessellatorShader("GLRender Tessellator", 0x200000);
 
     public GLRenderer() {
+        for (int i = 0; i < this.fogStateStack.length; i++) {
+            this.fogStateStack[i] = new FogManager.FogState().disable();
+        }
     }
 
     public static void init() {
@@ -426,7 +425,7 @@ public class GLRenderer {
         instance.stateConfigStack[instance.stackIndex] = instance.currentStateConfig;
         instance.colorStack[instance.stackIndex] = instance.currentColor;
         instance.shaderStack[instance.stackIndex] = instance.currentShader;
-        instance.fogStateStack[instance.stackIndex] = instance.currentFogState.copy();
+        instance.currentFogState.copy(instance.fogStateStack[instance.stackIndex]);
         instance.depthFuncStack[instance.stackIndex] = instance.currentDepthFunc;
         instance.cullFaceStack[instance.stackIndex] = instance.currentCullFace;
         instance.sFactorStack[instance.stackIndex] = instance.currentSFactor;
@@ -497,7 +496,7 @@ public class GLRenderer {
         if (!instance.currentFogState.equals(instance.fogStateStack[instance.stackIndex])) {
             instance.fogStateDirty = true;
         }
-        instance.currentFogState = instance.fogStateStack[instance.stackIndex];
+        instance.fogStateStack[instance.stackIndex].copy(instance.currentFogState);
 
         if (instance.currentDepthFunc != instance.depthFuncStack[instance.stackIndex]) {
             instance.currentDepthFunc = instance.depthFuncStack[instance.stackIndex];
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index 9f17936e6..148cba8c8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -71,8 +71,6 @@ public final class Shaders {
                     entry.getValue().uniformBlockBinding(block.name, block.index);
                 }
                 entry.getValue().bind();
-                GL41.glUniform1i(entry.getValue().getUniform("colortex"), 0);
-                GL41.glUniform1i(entry.getValue().getUniform("lighttex"), 1);
                 entry.getValue().uniformInt("colortex", 0);
                 entry.getValue().uniformInt("lighttex", 1);
                 entry.getValue().uniformInt("emissivetex", 2);
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
index 7f63cd00f..a33877451 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -116,6 +116,7 @@ public class Shader {
         this.enabled = false;
 
         this.uniformLocations.clear();
+        this.uniformBlockLocations.clear();
 
         OpenGLHelper.checkError("pre delete shader");
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 1acaff6e8..cb648f933 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -198,8 +198,8 @@ public class ShadersRenderer implements Renderer {
     public void setupFramebuffer() {
         double renderScale = (float) GameSettings.RENDER_SCALE.value.scale;
 
-        int scaledWidth = (int) (renderScale * this.mc.gameWindow.getWidthPixels());
-        int scaledHeight = (int) (renderScale * this.mc.gameWindow.getHeightPixels());
+        int scaledWidth = Math.max((int) (renderScale * this.mc.gameWindow.getWidthPixels()), 1);
+        int scaledHeight = Math.max((int) (renderScale * this.mc.gameWindow.getHeightPixels()), 1);
 
         if (
             this.worldFrameBuffer == null ||
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index ccce9eb04..0a6db20a8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -13,14 +13,14 @@ import org.joml.primitives.AABBd;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public abstract class ChunkRenderer {
     public static final int MAX_RENDER_PASSES = 2;
     public static int updates = 0;
 
-    public final boolean @NotNull [] empty = new boolean[MAX_RENDER_PASSES];
+//    public final boolean @NotNull [] empty = new boolean[MAX_RENDER_PASSES];
+    public byte emptyBitSet = 0;
 
     public boolean visible = false;
     public int id = -1;
@@ -91,8 +91,10 @@ public abstract class ChunkRenderer {
     }
 
     public void reset() {
+        this.emptyBitSet = 0;
         for (int i = 0; i < MAX_RENDER_PASSES; i++) {
-            this.empty[i] = true;
+//            this.empty[i] = true;
+            this.emptyBitSet |= (byte) (1 << i);
         }
 
         this.visible = false;
@@ -108,11 +110,12 @@ public abstract class ChunkRenderer {
         this.visible = frustum.isVisible(this.bb, partialTick);
     }
 
-    public boolean isEmpty() {
+    public final boolean isEmpty() {
         if (!this.compiled) {
             return false;
         } else {
-            return this.empty[0] && this.empty[1];
+            return this.emptyBitSet == 0b11;
+//            return this.empty[0] && this.empty[1];
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index a49744192..b9f29d5ec 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -124,7 +124,8 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
             }
 
             if (hasRenderedBlock) {
-                this.empty[renderPass] = false;
+//                this.empty[renderPass] = false;
+                this.emptyBitSet &= (byte) ~(1 << renderPass);
             }
             if (!needsMoreRenderPasses) {
                 break;
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
index a36419034..8d0da9eeb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
@@ -1,18 +1,14 @@
 package net.minecraft.client.render.terrain;
 
-import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
-import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.jetbrains.annotations.UnmodifiableView;
 
 import java.util.ArrayList;
 import java.util.Collections;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 
 public class RegionBuffer<V extends VertexConfig<V>> {
     private final @NotNull Int2ObjectMap<@NotNull RenderRegion<V>> regionMap = new Int2ObjectOpenHashMap<>();
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index 1fa6d23c5..0d09677e7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -20,9 +20,9 @@ import java.util.Objects;
 
 public class TerrainRendererMultiDraw extends TerrainRenderer {
 
-    public static final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
+    public static final int VERTEX_BUFFER_INITIAL_CAPACITY = 128 * 1024 * 1024;
 
-    public static final int RENDER_LIST_INITIAL_CAPACITY = 4096;
+    public static final int RENDER_LIST_INITIAL_CAPACITY = 8192;
 
     /**
      * Exponential Region Size
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
index de715ee04..f52c164ab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -4,7 +4,6 @@ import static org.lwjgl.opengl.GL41.*;
 
 import java.util.ArrayList;
 import java.util.List;
-import java.util.Objects;
 
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
@@ -37,7 +36,7 @@ public class VertexBuffer {
         this.vbo = glGenBuffers();
         this.vao = GL41.glGenVertexArrays();
         glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
-        glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_STATIC_DRAW);
+        glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_DYNAMIC_DRAW);
         glBindBuffer(GL_ARRAY_BUFFER, 0);
     }
 
@@ -127,20 +126,20 @@ public class VertexBuffer {
     }
 
     private void expandVBO() {
-        final long prevCapacity = this.capacity;
-        final long newCapacity = this.capacity * 2L;
+//        final long prevCapacity = this.capacity;
+        final long newCapacity = (this.capacity * 3L) >>> 1L;
         if (newCapacity < this.capacity) {
             // future proof
             throw new RuntimeException();
         }
 
-        LOGGER.warn("Expand VBO Buffer: " + newCapacity);
+        LOGGER.warn("Expand VBO Buffer: {}", newCapacity);
 
         OpenGLHelper.checkError("pre expand buffer");
 
         final int newBuffer = glGenBuffers();
         glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
-        glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_STATIC_DRAW);
+        glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_DYNAMIC_DRAW);
 
         OpenGLHelper.checkError("create expand buffer");
 
@@ -154,6 +153,8 @@ public class VertexBuffer {
 
         OpenGLHelper.checkError("copy buffer");
 
+        GL41.glDeleteBuffers(this.vbo); // Delete old buffer
+
         this.capacity = newCapacity;
         this.vbo = newBuffer;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 837ebd3aa..52f300e11 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -4,7 +4,6 @@ import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.TextOutlineQuality;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.font.Font;
 import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.render.font.SF;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -251,13 +250,12 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
                 entry.lastUse = System.currentTimeMillis();
                 buffer = entry.buffer;
             } else {
-                Font font = sr.getFont();
-                sr.getTessellator().startDrawing();
-                sr.renderStringRaw(font, line1, -sr.stringWidth(line1) / 2, 0, 0, false, config);
-                sr.renderStringRaw(font, line2, -sr.stringWidth(line2) / 2, 10, 0, false, config);
-                sr.renderStringRaw(font, line3, -sr.stringWidth(line3) / 2, 20, 0, false, config);
-                sr.renderStringRaw(font, line4, -sr.stringWidth(line4) / 2, 30, 0, false, config);
-                buffer = sr.getTessellator().record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
+                sr.startDrawingDeferred();
+                sr.render(line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
+                sr.render(line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
+                sr.render(line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
+                sr.render(line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
+                buffer = sr.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
                 MeshEntry entry = new MeshEntry(line1, line2, line3, line4, config);
                 entry.buffer = buffer;
                 entry.lastUse = System.currentTimeMillis();
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index eeaa04eca..63634b71b 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -95,6 +95,7 @@ public class DebugRender {
         int x = w - frametimes.length;
         int y = h;
 
+        t.startDrawingQuads();
         if (selectedProfiler != Debug.baseProfiler) {
             if (w > frametimes.length + baseframetimes.length) {
                 drawFrameTimes(t, x, y, baseframetimes);
@@ -103,6 +104,7 @@ public class DebugRender {
         } else {
             drawFrameTimes(t, 0, y, baseframetimes);
         }
+        t.draw();
 
         GLRenderer.disableState(State.BLEND);
         GLRenderer.setShader(Shaders.INTERFACE);
@@ -117,6 +119,7 @@ public class DebugRender {
         y1 = 0;
         GLRenderer.modelM4f().scale(2.0f, 2.0f, 2.0f);
 
+        sr.startDrawingDeferred();
         int fps = Debug.getFps();
         if (fps >= 0) {
             sr.render("fps: " + fps, x1, y1 - 2 * lineHeight).call();
@@ -132,6 +135,7 @@ public class DebugRender {
             }
             sr.render(i + ": " + profiler.name, x1, y1 + (i + 1) * lineHeight).setColor(color).call();
         }
+        sr.draw(0);
 //		glEnable(GL_ALPHA_TEST);
         GLRenderer.popFrame();
     }
@@ -157,7 +161,6 @@ public class DebugRender {
         int h1 = 16666666 / scale;
         int h2 = 33333333 / scale;
 
-        tessellator.startDrawingQuads();
         tessellator.setColor4i(0, 0, 0, 127);
         drawRectangle(tessellator, x, y - h2, frametimes.length, h2);
         drawRectangle(tessellator, x, y - h1, frametimes.length, h1);
@@ -192,7 +195,6 @@ public class DebugRender {
             drawRectangle(tessellator, x, y - frameLagHeight, frametimes.length, 1);
         }
 
-        tessellator.draw();
     }
 
     private static void drawRectangle(TessellatorGeneral tessellator, int x, int y, int w, int h) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index d161131d3..241264472 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -253,6 +253,11 @@ interface BlockInterface {
         this.onActivatorInteracted(world, new TilePos(x, y, z), activator, direction);
     }
 
+
+    /**
+     * This is only called when the player would make a step noise, and only when they'd make a step noise which makes it
+     * quite hard to actually use for things
+     */
     void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity walker);
 
     @Deprecated
